## class SG_EXPORT osg::ClearNode

> ClearNode is a Group node which controls the clearing of the color and depth buffers at the start of each frame.

## Inheritance:

### Public Methods

ClearNode()
ClearNode(const ClearNode& es, const CopyOp& copyop=CopyOp::SHALLOW_COPY)
META_Node(osg, ClearNode)
inline void setRequiresClear(bool requiresClear)
  Sets the flag which control whether a glClear is required at the beginning of each frame.
inline bool getRequiresClear() const
  Gets the flag which control whether a glClear is required at the beginning of each frame.
inline void setClearColor(const Vec4& color)
  Sets the clear color.
inline const Vec4& getClearColor() const
  Returns the clear color.

### Protected Fields

bool _requiresClear
Vec4 _clearColor

### Protected Methods

virtual ~ClearNode()

### Inherited from Group:

### Public Methods

virtual Group* asGroup()
virtual const Group* asGroup() const
virtual void traverse(NodeVisitor& nv)
virtual bool addChild( Node* child )
virtual bool insertChild( unsigned int index, Node* child )
virtual bool removeChild( Node* child )
virtual bool removeChild(unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool replaceChild( Node* origChild, Node* newChild )
inline unsigned int getNumChildren() const
virtual bool setChild( unsigned int i, Node* node )
inline Node* getChild( unsigned int i )
inline const Node* getChild( unsigned int i ) const
inline bool containsNode( const Node* node ) const
inline unsigned int getChildIndex( const Node* node ) const

### Protected Fields

NodeList _children

### Protected Methods

virtual bool computeBound() const

### Inherited from Node:

### Public Methods

virtual Object* cloneType() const
virtual Object* clone(const CopyOp& copyop) const
virtual bool isSameKindAs(const Object* obj) const
virtual const char* libraryName() const
virtual const char* className() const
virtual Transform* asTransform()
virtual const Transform* asTransform() const
virtual void accept(NodeVisitor& nv)
virtual void ascend(NodeVisitor& nv)
inline void setName( const std::string& name )
inline void setName( const char* name )
inline const std::string& getName() const
inline const ParentList& getParents() const
inline ParentList getParents()
inline Group* getParent(unsigned int i)
inline const Group* getParent(unsigned int i) const
inline unsigned int getNumParents() const
void setUpdateCallback(NodeCallback* nc)
inline NodeCallback* getUpdateCallback()
inline const NodeCallback* getUpdateCallback() const
inline unsigned int getNumChildrenRequiringUpdateTraversal() const
void setCullCallback(NodeCallback* nc)
inline NodeCallback* getCullCallback()
inline const NodeCallback* getCullCallback() const
void setCullingActive(bool active)
inline bool getCullingActive() const
inline unsigned int getNumChildrenWithCullingDisabled() const
inline bool isCullingActive() const
inline unsigned int getNumChildrenWithOccluderNodes() const
bool containsOccluderNodes() const
inline void setNodeMask(NodeMask nm)
inline NodeMask getNodeMask() const
inline const DescriptionList& getDescriptions() const
inline DescriptionList& getDescriptions()
inline const std::string& getDescription(unsigned int i) const
inline std::string& getDescription(unsigned int i)
inline unsigned int getNumDescriptions() const
void addDescription(const std::string& desc)
inline void setStateSet(osg::StateSet* dstate)
osg::StateSet* getOrCreateStateSet()
inline osg::StateSet* getStateSet()
inline const osg::StateSet* getStateSet() const
inline const BoundingSphere& getBound() const
void dirtyBound()

### Public Members

typedef std::vector<Group*> ParentList
typedef unsigned int NodeMask
typedef std::vector<std::string> DescriptionList

### Protected Fields

mutable BoundingSphere _bsphere
mutable bool _bsphere_computed
std::string _name
ParentList _parents
ref_ptr<NodeCallback> _updateCallback
unsigned int _numChildrenRequiringUpdateTraversal
ref_ptr<NodeCallback> _cullCallback
bool _cullingActive
unsigned int _numChildrenWithCullingDisabled
unsigned int _numChildrenWithOccluderNodes
NodeMask _nodeMask
DescriptionList _descriptions
ref_ptr<StateSet> _stateset

### Protected Methods

void addParent(osg::Group* node)
void removeParent(osg::Group* node)
void setNumChildrenRequiringUpdateTraversal(unsigned int num)
void setNumChildrenWithCullingDisabled(unsigned int num)
void setNumChildrenWithOccluderNodes(unsigned int num)

### Inherited from Object:

### Public Methods

inline void setDataVariance(DataVariance dv)
inline DataVariance getDataVariance() const
inline void setUserData(Referenced* obj)
inline Referenced* getUserData()
inline const Referenced* getUserData() const

### Public Members

enum DataVariance

### Protected Fields

DataVariance _dataVariance
ref_ptr<Referenced> _userData

### Inherited from Referenced:

### Public Methods

inline Referenced& operator = (Referenced&)
static void setDeleteHandler(DeleteHandler* handler)
static DeleteHandler* getDeleteHandler()
inline void ref() const
inline void unref_nodelete() const
inline int referenceCount() const
inline void unref() const

### Protected Fields

mutable int _refCount

## Documentation

> ClearNode is a Group node which controls the clearing of the color and depth buffers at the start of each frame. The earth sky by default is empty and simply holds the clear color of the background. However, if the uses wants to add their own clearing of the color and depth buffers then the children can be added, and the background clear turned off. The ClearNode by default has StateSet attached to it which sets the default ClearNode bin number to -1, so that all drawables below it are placed in a separate bin from the rest of the scene graph, and are rendered prior to standard opaque and transparent drawables.

`ClearNode()`

`ClearNode(const ClearNode& es, const CopyOp& copyop=CopyOp::SHALLOW_COPY)`

`META_Node(osg, ClearNode)`

`inline void setRequiresClear(bool requiresClear)`
  Sets the flag which control whether a glClear is required at the beginning of each frame.

`inline bool getRequiresClear() const`
  Gets the flag which control whether a glClear is required at the beginning of each frame.

`inline void setClearColor(const Vec4& color)`
  Sets the clear color.

`inline const Vec4& getClearColor() const`
  Returns the clear color.

`virtual ~ClearNode()`

`bool _requiresClear`

`Vec4 _clearColor`

This class has no child classes.

Alphabetic index HTML hierarchy of classes or Java

This page was generated with the help of DOC++.